The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::Whistle Class Reference

STK police/referee whistle instrument class. More...

`#include <Whistle.h>`

Inheritance diagram for stk::Whistle:

List of all members.

## Public Member Functions
| Whistle (void)
| Class constructor.
| ~Whistle (void)
| Class destructor.
void | clear (void)
| Reset and clear all internal state.
void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
void | startBlowing (StkFloat amplitude, StkFloat rate)
| Apply breath velocity to instrument with given amplitude and rate of increase.
void | stopBlowing (StkFloat rate)
| Decrease breath velocity with given rate of decrease.
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
void | noteOff (StkFloat amplitude)
| Stop a note with the given amplitude (speed of decay).
void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

STK police/referee whistle instrument class.

This class implements a hybrid physical/spectral model of a police whistle (a la Cook).

Control Change Numbers:

- Noise Gain = 4
- Fipple Modulation Frequency = 11
- Fipple Modulation Gain = 1
- Blowing Frequency Modulation = 2
- Volume = 128

by Perry R. Cook 1995-2012.

## Constructor & Destructor Documentation

stk::Whistle::Whistle | ( | void |  | ) |

Class constructor.

An StkError will be thrown if the rawwave path is incorrectly set.

## Member Function Documentation

StkFrames & stk::Whistle::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Instrmnt.

    00101 {
    00102   unsigned int nChannels = lastFrame_.channels();
    00103 #if defined(_STK_DEBUG_)
    00104   if ( channel > frames.channels() - nChannels ) {
    00105     oStream_ << "Whistle::tick(): channel and StkFrames arguments are incompatible!";
    00106     handleError( StkError::FUNCTION_ARGUMENT );
    00107   }
    00108 #endif
    00109
    00110   StkFloat *samples = &frames[channel];
    00111   unsigned int j, hop = frames.channels() - nChannels;
    00112   if ( nChannels == 1 ) {
    00113     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00114       *samples++ = tick();
    00115   }
    00116   else {
    00117     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00118       *samples++ = tick();
    00119       for ( j=1; j<nChannels; j++ )
    00120         *samples++ = lastFrame_[j];
    00121     }
    00122   }
    00123
    00124   return frames;
    00125 }

The documentation for this class was generated from the following file:

- Whistle.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.